NewPolyRing with user defined ordering is slower than CoCoALib

18 Apr 2017 10:58 - Anna Maria Bigatti

Status: Closed Start date: 18 Apr 2017

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: enhancing/improving Estimated time: 5.31 hours

Target version: CoCoA-5.2.0 spring 2017 Spent time: 5.20 hours

Description

Related issues:

Related to CoCoALib - Slug #1049: GroebnerFan: slow examples In Progress 19 Apr 2017

Related to CoCoALib - Slug #1057: Slug: Polynomial ring contructor slow with ... In Progress 04 May 2017

History

#1 - 18 Apr 2017 11:11 - Anna Maria Bigatti

- Category set to enhancing/improving

- Status changed from New to Feedback

- Assignee set to Anna Maria Bigatti

- Priority changed from Normal to High

- Target version set to CoCoA-5.2.0 spring 2017

- % Done changed from 0 to 90

- Estimated time set to 4.01 h

Of course I wrote this issue after solving it ;-)

While comparing two functions using GBases with an elimination ordering we (Robbiano and myself) realized that the CoCoA-5 function was curiously

a lot slower than the similar CoCoALib one.

After a long investigation (and resurrecting the old code for GRStats) I understood that the problem had to be in the underlying polynomial arithmetic.

Indeed NewPolyRing in BuiltinFunctions-CoCoALib.C was calling NewPolyRing(R->theRing, NewPPMonoid(syms, PPO)), which forces a PPMonoid,

then preventing the use of $DMPII$ (I think this was implemented before we wrote the new function below).

The correct call is NewPolyRing(R->theRing, syms, PPO).

#2 - 19 Apr 2017 18:43 - Anna Maria Bigatti

- Related to Slug #1049: GroebnerFan: slow examples added

#3 - 29 Apr 2017 08:39 - Anna Maria Bigatti

- Estimated time changed from 4.01 h to 5.01 h

Still missing: make speed tests with GroebnerFan (I had some strange results)

#4 - 01 May 2017 10:43 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time changed from 5.01 h to 5.31 h
Anna Maria Bigatti wrote:

Still missing: make speed tests with GroebnerFan (I had some strange results)

 

The timing for GroebnerFan is identical because GBasis make its own ring (DMPI/DMPII) for the computation.

Our experiments, instead, had some computations in the cocoa5 ring (implemented as DMP).

#5 - 16 May 2017 15:24 - Anna Maria Bigatti

- Related to Slug #1057: Slug: Polynomial ring contructor slow with (big) matrix ordering added
